## texlive-base 2013.20130722

=== regressiontests/Makefile ===
# This is a regression-test framework for tex.
#
# The idea is as follows:
#
# 1. there is a reference revision on which a unittest runs as expected.
# 2. there is a way to generate the reference image (to pdf and to png)
# 3. you can compile the actual image
# 4. you can "diff" the actual image and the reference (and view the difference)
# 5. you can create a log of the single results and diffs
#
# This makefile can do all of these steps.
#
# The references can be generated with
# >> make references
# References are stored in a sub-folder called "references". You can *REMOVE* this directory
# to clean references.
#
# References are compiled using different revisions of the code; they are checked out into /tmp. 
#
#
# HOW TO WRITE TESTS
# Simply write a minimal, self-contained .tex file (say, unittest_42.tex) in this directory. It can have multiple
# pages.
# 
# If a test contains \FIXIT, it is marked as "this test is known to be broken - test issue"
#
#
# If your example needs a specific reference revision, create a file <base>.checkoutreferencerev.sh which contains something
# like "git checkout 1.3.1" . It will be invoked to checkout the reference revision.
#
# If your example needs a specific command to translate it, create a file <base>.compile.sh which runs it. Its first argument will be the base file name (without .tex).
#
# Then, type "make unittest_42.diff" to create reference, actual, and difference.
#
# Typing 'make' will make all unittests (all *.tex files in this directory).
#  
# COMPILING TESTS
# 1. compile reference, actual, and diff:
# >> make unittest_polar_7.diff
# 2. compile reference only
# >> make references/unittest_polar_7.pdf
# 3. compile actual only
# >> make unittest_polar_7.pdf
#
# The makefile will avoid re-creation of test cases in order to allow concentrate on failures.
# If you want to remake tests, you can either type 
# >> make clean
# or you can use the (standard) make feature 
# >> make unittest_polar_7.diff -B
# which forces remake, even if modtimes are unchanged 
#
#
# SPECIALTIES:
# create a file unittest_*.diff.accepted containing accepted diff results 
# (in case you approved that they are "not an error"). 
# The file should contain what the failure-output of the 'make test.diff' target.

UNIT_SOURCES=$(wildcard unittest_*.tex)

UNIT_PDFS=$(UNIT_SOURCES:.tex=.pdf)
DIFF_MEASURES=$(UNIT_SOURCES:.tex=.diff)

# REQUIRES apcalc package ('calc' executable)
ACCEPTED_NORMALIZED_ERROR=5e-4
DIRECTORY_FOR_ACCEPTED_ERRORS=./pgfplotsUTaccepted

INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY=plotdata/risingdrop3d.png plotdata/plotgraphics3dsurf.png

# -------------------------------------------------
# stuff for references:
# allow dynamic creation of reference files. I have never used something else.
ENABLE_DYNAMIC_REFERENCES=1

STATISTICS=$$(ls unittest_*.pdf | wc -l)/$$(ls unittest_*.tex | wc -l) [F=$$(ls unittest_*.diff.png | wc -l)]

UNIT_PDF_REFERENCES=$(UNIT_SOURCES:%.tex=references/%.pdf)
WORKING_DIR=$(shell pwd)
PGFPLOTS_GIT_BASEDIR=$(WORKING_DIR:source/latex/pgfplots/pgfplotstest/regressiontests=)
TMP_REPOSITORY=/tmp/pgfplots_copy
DEFAULT_REFERENCE_BRANCH:=$(shell git describe --tags HEAD)

PGF_CVS_PATH=~/code/tex/pgf

.PRECIOUS:  $(UNIT_SOURCES:%.tex=%.checkoutreferencerev.sh) $(UNIT_SOURCES:%.tex=%.compile.sh) $(UNIT_PDF_REFERENCES) $(UNIT_SOURCES:%.tex=%.pdf)

AUTO_INDENT_PIPE=2>&1 | sed -e 's/^/  /'
$(shell mkdir -p gnuplot references/gnuplot references/plotdata)
# -------------------------------------------------

.NOTPARALLEL:

# .PRECIOUS: $(UNIT_PNGS)

.PHONY: references pdf png  cleanX clean setupdirs

diff: $(DIFF_MEASURES) 

pdf: $(UNIT_PDFS) 

clean: cleanX
	rm -fr references 

# clean all except for references:
cleanX:
	rm -fr $(DIFF_MEASURES) $(UNIT_PDFS) unittest*.png $(DIRECTORY_FOR_ACCEPTED_ERRORS)

%.diff.png: %.diff
	@

%.diff: %.pdf references/%.pdf
	@echo "$<: diffing --> $@ ..."
	@./pdfdiff.sh $< references/$< $@
	@if [ "`cat $@`" = "0 (0)" ]; then \
		echo "  PASSED: no differences detected (removing superfluos diff-pngs)"; \
		rm -f $@.png $<.png $(DIRECTORY_FOR_ACCEPTED_ERRORS)/$@ $(DIRECTORY_FOR_ACCEPTED_ERRORS)/$@.png; # no need to keep the images (the latter for multi-page mode). \
	else \
		#echo "$<: found nonzero pixel differences `cat $@`."; \
		sed -e 's/.*(\(.*\)).*/\1/' < $@  > $@.normalized || exit 1; \
		NORMALIZED=`cat $@.normalized`; \
		rm -f $@.normalized; \
		calc -p "$$NORMALIZED < $(ACCEPTED_NORMALIZED_ERROR)" > $@.isaccepted || ( echo "calc invocation failed. Please ensure that apcalc package is installed."; exit 1 ); \
		if [ ! -f $@.accepted -a "`cat $@.isaccepted`" = "1" ]; then \
			echo "  PASSED: only approved differences `cat $@` detected and no *.accepted (less than $(ACCEPTED_NORMALIZED_ERROR); moving superfluos diff-pngs to $(DIRECTORY_FOR_ACCEPTED_ERRORS))"; \
			mkdir -p $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			mv $@.png $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			cp $@ $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			rm -f $@.png $<.png; # no need to keep the images (the latter for multi-page mode). \
		elif [ -f $@.accepted -a "`cat $@`" = "`cat $@.accepted`" ]; then \
			echo "  PASSED: only manually approved differences `cat $@` detected (moving superfluos diff-pngs to $(DIRECTORY_FOR_ACCEPTED_ERRORS))"; \
			mkdir -p $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			mv $@.png $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			cp $@ $(DIRECTORY_FOR_ACCEPTED_ERRORS); \
			rm -f $@.png $<.png; # no need to keep the images (the latter for multi-page mode). \
		else \
			echo "  FAILURE: found pixel differences for $<: " `cat $@`; \
			echo "  (if not a bug: 'echo \"`cat $@`\" > $@.accepted')"; \
			echo "  Call './displayDiff.sh $@.png' (see summarize of regressions.sh)"; \
			rm $@; # make sure it will be recomputed! \
			false; \
		fi; \
		CODE=$$?; \
		rm -f $@.isaccepted; \
		exit $$CODE; \
	fi
		


#	convert $< -append $@
#	@diff $@ references/$@; \
#	if [ ! $$? -eq 0 ]; then \
#		echo 'convert "$@" "references/$@" -compose difference -composite -colorspace gray miff:- | display' > $(@:.png=.regression.sh); \
#		echo "echo $@" >> regressions.sh; \
#		echo "sh $(@:.png=.regression.sh)" >> regressions.sh; \
#		echo "$@ WAS UNEXPECTED. See regressions.sh"; \
#		touch -t 01010000 $@; # make sure its older MMDDHHSS\
#		false;\
#	fi
	
		

references: $(UNIT_PDF_REFERENCES)

%.checkoutreferencerev.sh:
	@if [ ! -f $@ ]; then pwd; echo "generating $@ (with $(DEFAULT_REFERENCE_BRANCH))..."; echo "git checkout $(DEFAULT_REFERENCE_BRANCH)" > $@ || exit 1; fi

ifeq ($(ENABLE_DYNAMIC_REFERENCES),1)

references/%.pdf: %.tex %.checkoutreferencerev.sh %.compile.sh
	@echo "$<: generating $@"; \
	REFERENCE_SCRIPT=$(<:.tex=.checkoutreferencerev.sh);\
	#echo "  checking out reverence revision to $(TMP_REPOSITORY)..."; \
	if [ ! -d $(TMP_REPOSITORY) ]; then \
		cd $(dir $(TMP_REPOSITORY)) || exit 1; \
		git clone $(PGFPLOTS_GIT_BASEDIR) $(notdir $(TMP_REPOSITORY)) || exit 1; \
	fi; \
	cd $(TMP_REPOSITORY) || exit 1; \
	cat $(WORKING_DIR)/$$REFERENCE_SCRIPT $(AUTO_INDENT_PIPE); \
	sh $(WORKING_DIR)/$$REFERENCE_SCRIPT  1>/dev/null 2>&1; \
	if [ $$? -ne 0 ]; then \
		echo "CHECKOUT FAILED." $(AUTO_INDENT_PIPE); \
		echo "(cleaning $(TMP_REPOSITORY))..." $(AUTO_INDENT_PIPE); \
		rm -fr $(TMP_REPOSITORY); \
		exit 1; \
	fi
	@cd references || exit 1;\
	export TEXINPUTS=.:..:$(TMP_REPOSITORY)/tex//:$(PGF_CVS_PATH)/generic//:$(PGF_CVS_PATH)/latex//:$(TEXINPUTS); \
	echo "export TEXINPUTS=$${TEXINPUTS}:\$$TEXINPUTS" $(AUTO_INDENT_PIPE); \
	echo "cd references && \"compile $<\" ..." $(AUTO_INDENT_PIPE); \
	# create *.diff.png -> this makes it much more visible that it failed: \
	sh ../$(<:.tex=.compile.sh) $(<:.tex=) 1>/dev/null 2>&1 || \
		( sh ../../scripts/compile_failed.sh "../$<" "$@" "\nPlease check $(<:.tex=.checkoutreferencerev.sh)" $(AUTO_INDENT_PIPE); exit 1 )

else
#disable dynamic reference (re-)creation:
references/%.pdf: %.tex 
	@if [ ! -f $@ ]; then echo "  REFERENCE IS MISSING AND CAN'T BE CREATED AUTOMATICALLY (ENABLE_DYNAMIC_REFERENCES=0)"; exit 1; fi

endif

# make sure this rule is AFTER references/%.pdf !
%.pdf: %.tex %.compile.sh $(INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY)
	@echo "$(STATISTICS) $@: recompiling $< ..."
	@rm -f $@; sh ./$(@:.pdf=.compile.sh) $(<:.tex=) >/dev/null 2>&1  || \
		( sh ../scripts/compile_failed.sh "$<" "$@" "" $(AUTO_INDENT_PIPE); exit 1 )

%.compile.sh:
	@if [ ! -f $@ ]; then echo "generating default $@ ..."; echo 'pdflatex -shell-escape -interaction batchmode -halt-on-error "$$@"' > $@; fi

# temporary links to graphics which are in the doc directory:
# see $(INCLUDE_GRAPHICS_FROM_DIR_DIRECTORY)
plotdata/%: 
	cd plotdata && ln -fs ../../../../../../doc/latex/pgfplots/plotdata/$(notdir $@)

=== texmf-dist/source/luatex/lualibs/Makefile ===
# Makefile for lualibs.

NAME = lualibs
DTX = $(wildcard *.dtx)
DOC_DTX = $(patsubst %.dtx, %.pdf, $(DTX))
LUALIBS	= $(wildcard lualibs-*.lua)
MODULES = $(filter-out $(UNPACKED),$(LUALIBS))

# Files grouped by generation mode
TESTSCRIPT 		= test-lualibs.lua
DIFFSCRIPT 		= whatsnew.lua
SCRIPTS			= $(TESTSCRIPT) $(DIFFSCRIPT)
UNPACKED		= lualibs.lua lualibs-extended.lua lualibs-basic.lua
COMPILED 		= $(DOC_DTX)
GENERATED 		= $(UNPACKED) $(DOC_DTX) $(MERGED)
SOURCE 			= $(DTX) $(MODULES) $(SCRIPTS) LICENSE README Makefile NEWS
MERGED 			= lualibs-basic-merged.lua lualibs-extended-merged.lua

# Files grouped by installation location
RUNFILES = $(UNPACKED) $(MODULES)
DOCFILES = $(DOC_DTX) LICENSE README NEWS
SRCFILES = $(DTX) $(SRC_TEX) Makefile $(SCRIPTS)

# The following definitions should be equivalent
# ALL_FILES = $(RUNFILES) $(DOCFILES) $(SRCFILES)
ALL_FILES = $(GENERATED) $(SOURCE)

# Installation locations
FORMAT = luatex
RUNDIR = $(TEXMFROOT)/tex/$(FORMAT)/$(NAME)
DOCDIR = $(TEXMFROOT)/doc/$(FORMAT)/$(NAME)
SRCDIR = $(TEXMFROOT)/source/$(FORMAT)/$(NAME)
TEXMFROOT = ./texmf

CTAN_ZIP = $(NAME).zip
TDS_ZIP = $(NAME).tds.zip
ZIPS = $(CTAN_ZIP) $(TDS_ZIP)

DO_TEX 			= luatex     --interaction=batchmode $< >/dev/null
DO_PDFLATEX 	= latexmk -pdf -e '$$pdflatex = q(lualatex %O %S)' -silent $< >/dev/null
DO_MAKEINDEX 	= makeindex  -s gind.ist $(subst .dtx,,$<) >/dev/null 2>&1
DO_PACKAGE 		= mtxrun     --script package --merge $< >/dev/null

all: $(GENERATED) $(DOC_TEX)
doc: $(COMPILED)
unpack: $(UNPACKED)
ctan: check $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

check: $(TESTSCRIPT)
	@texlua $(TESTSCRIPT)

news: $(DIFFSCRIPT)
	@texlua $(DIFFSCRIPT)

.PHONY: all doc unpack ctan tds world

%.pdf: %.dtx
	$(DO_PDFLATEX)
	$(DO_MAKEINDEX)
	$(DO_PDFLATEX)
	$(DO_PDFLATEX)

%-merged.lua: %.lua
	$(DO_PACKAGE)

$(UNPACKED): lualibs.dtx
	$(DO_TEX)

$(CTAN_ZIP): $(SOURCE) $(COMPILED) $(GENERATED) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	@zip -9 $@ $^ >/dev/null

define run-install
@mkdir -p $(RUNDIR) && cp $(RUNFILES) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCFILES) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCFILES) $(SRCDIR)
endef

$(TDS_ZIP): TEXMFROOT=./tmp-texmf
$(TDS_ZIP): $(ALL_FILES)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	$(run-install)
	@cd $(TEXMFROOT) && zip -9 ../$@ -r . >/dev/null
	@$(RM) -r -- $(TEXMFROOT)

.PHONY: install manifest clean mrproper

install: $(ALL_FILES)
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

manifest: 
	@echo "Source files:"
	@for f in $(SOURCE); do echo $$f; done
	@echo ""
	@echo "Derived files:"
	@for f in $(GENERATED); do echo $$f; done

clean: 
	@$(RM) -- *.log *.aux *.toc *.idx *.ind *.ilg

mrproper: clean
	@$(RM) -- $(GENERATED) $(ZIPS)

merge: $(MERGED)

=== texmf-dist/source/luatex/luamplib/Makefile ===
NAME      = luamplib
FORMAT    = luatex

DTX       = $(NAME).dtx
DOC       = $(NAME).pdf
STY       = $(NAME).sty
LUA       = $(NAME).lua
TEST      = test-$(NAME)-plain.tex test-$(NAME)-latex.tex

UNPACKED  = $(STY) $(LUA)
GENERATED = $(UNPACKED) $(DOC)
SOURCES   = $(DTX) README NEWS Makefile $(TEST)

DOCFILES  = $(DOC) $(TEST) README NEWS
SRCFILES  = $(DTX) Makefile
RUNFILES  = $(STY) $(LUA)

ALL       = $(SRCFILES) $(DOCFILES) $(RUNFILES)

TEXMFROOT = ./texmf
RUNDIR    = $(TEXMFROOT)/tex/$(FORMAT)/$(NAME)
DOCDIR    = $(TEXMFROOT)/doc/$(FORMAT)/$(NAME)
SRCDIR    = $(TEXMFROOT)/source/$(FORMAT)/$(NAME)

CTAN_ZIP  = $(NAME).zip
TDS_ZIP   = $(NAME).tds.zip
ZIPS      = $(CTAN_ZIP) $(TDS_ZIP)

all: $(GENERATED)
doc: $(DOC)
unpack: $(UNPACKED)
ctan: check $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

.PHONY: all doc unpack ctan tds check world

%.pdf: %.dtx
	latexmk -pdf -e '$$pdflatex = q(lualatex %O %S)' -silent $< >/dev/null

$(UNPACKED): $(DTX)
	tex -interaction=batchmode $< >/dev/null

check: $(UNPACKED)
	luatex   -interaction=batchmode test-$(NAME)-plain.tex  >/dev/null
	lualatex -interaction=batchmode test-$(NAME)-latex.tex  >/dev/null
#	! grep "blank space"              test-$(NAME)-plain.log
#	! grep "blank space"              test-$(NAME)-latex.log

$(CTAN_ZIP): $(SOURCES) $(DOC) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	@zip -9 $@ $^ >/dev/null

define run-install
@mkdir -p $(RUNDIR) && cp $(RUNFILES) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCFILES) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCFILES) $(SRCDIR)
endef

$(TDS_ZIP): TEXMFROOT=./tmp-texmf
$(TDS_ZIP): $(ALL)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	@if test -e $(TEXMFROOT); then echo 'bad TEXMFROOT'; false; fi
	$(run-install)
	@cd $(TEXMFROOT) && zip -q -9 ../$@ -r .
	@$(RM) -r -- $(TEXMFROOT)

.PHONY: install clean mrproper help

install: check $(ALL)
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

clean:
	@latexmk -silent -c $(DTX) *.tex >/dev/null
	@rm -f -- *.log test*.pdf

mrproper: clean
	@rm -f -- $(GENERATED) $(ZIPS)

help:
	@echo '$(NAME) makefile targets:'
	@echo '                      help - (this message)'
	@echo '                       all - (default target) all generated files'
	@echo '                     world - synonymous for ctan'
	@echo '                    unpack - extract all files'
	@echo '                       doc - compile documentation'
	@echo '                      ctan - run check & generate archive for CTAN'
	@echo '                       tds - generate a TDS compliant archive'
	@echo '                     check - run the test files'
	@echo '  install TEXMFROOT=<path> - install in <path>'

=== texmf-dist/source/luatex/luaotfload/Makefile ===
# Makefile for luaotfload

NAME         = luaotfload
DOC          = $(NAME).pdf
DTX          = $(NAME).dtx
OTFL         = $(wildcard luaotfload-*.lua) luaotfload-blacklist.cnf

GLYPHSCRIPT  = mkglyphlist
GLYPHSOURCE  = glyphlist.txt
CHARSCRIPT   = mkcharacters
STATUSSCRIPT = mkstatus

RESOURCESCRIPTS = $(GLYPHSCRIPT) $(CHARSCRIPT) $(STATUSSCRIPT)

SCRIPTNAME   = luaotfload-tool
SCRIPT       = $(SCRIPTNAME).lua
MANSOURCE	 = $(SCRIPTNAME).rst
MANPAGE   	 = $(SCRIPTNAME).1
OLDSCRIPT    = luaotfload-legacy-tool.lua

GRAPH  		 = filegraph
DOTPDF 		 = $(GRAPH).pdf
DOT    		 = $(GRAPH).dot

# Files grouped by generation mode
GLYPHS      = luaotfload-glyphlist.lua
CHARS       = luaotfload-characters.lua
STATUS      = luaotfload-status.lua
RESOURCES	= $(GLYPHS) $(CHARS) $(STATUS)
GRAPHED     = $(DOTPDF)
MAN			= $(MANPAGE)
COMPILED    = $(DOC)
UNPACKED    = luaotfload.sty luaotfload.lua
GENERATED   = $(GRAPHED) $(UNPACKED) $(COMPILED) $(RESOURCES) $(MAN)
SOURCE 		= $(DTX) $(MANSOURCE) $(OTFL) README Makefile NEWS $(RESOURCESCRIPTS)

# test files
TESTDIR 		= tests
TESTSTATUS 		= $(wildcard $(TESTDIR)/*.tex $(TESTDIR)/*.ltx)
TESTSTATUS_SYS 	= $(TESTDIR)/systemfonts.tex $(TESTDIR)/fontconfig_conf_reading.tex
TESTSTATUS_TL 	= $(filter-out $(TESTSTATUS_SYS), $(TESTSTATUS))

# Files grouped by installation location
SCRIPTSTATUS = $(SCRIPT) $(OLDSCRIPT) $(RESOURCESCRIPTS)
RUNSTATUS    = $(UNPACKED) $(filter-out $(SCRIPTSTATUS),$(OTFL))
DOCSTATUS    = $(DOC) $(DOTPDF) README NEWS
MANSTATUS	= $(MANPAGE)
SRCSTATUS    = $(DTX) Makefile

# The following definitions should be equivalent
# ALL_STATUS = $(RUNSTATUS) $(DOCSTATUS) $(SRCSTATUS)
ALL_STATUS = $(GENERATED) $(SOURCE)

# Installation locations
FORMAT = luatex
SCRIPTDIR = $(TEXMFROOT)/scripts/$(NAME)
RUNDIR    = $(TEXMFROOT)/tex/$(FORMAT)/$(NAME)
DOCDIR    = $(TEXMFROOT)/doc/$(FORMAT)/$(NAME)
MANDIR    = $(TEXMFROOT)/doc/man/man1/
SRCDIR    = $(TEXMFROOT)/source/$(FORMAT)/$(NAME)
TEXMFROOT = $(shell kpsewhich --var-value TEXMFHOME)

CTAN_ZIP = $(NAME).zip
TDS_ZIP  = $(NAME).tds.zip
ZIPS 	 = $(CTAN_ZIP) $(TDS_ZIP)

LUA	= texlua

DO_TEX 		  	= luatex --interaction=batchmode $< >/dev/null
# (with the next version of latexmk: -pdf -pdflatex=lualatex)
DO_LATEX 	  	= latexmk -pdf -e '$$pdflatex=lualatex' -silent $< >/dev/null
DO_GRAPHVIZ 	= dot -Tpdf -o $@ $< > /dev/null
DO_GLYPHS 		= $(LUA) $(GLYPHSCRIPT) > /dev/null
DO_CHARS 		= $(LUA) $(CHARSCRIPT)  > /dev/null
DO_STATUS 		= $(LUA) $(STATUSSCRIPT)  > /dev/null
DO_DOCUTILS 	= rst2man $< >$@ 2>/dev/null

all: $(GENERATED)
graph: $(GRAPHED)
doc: $(GRAPHED) $(COMPILED) $(MAN)
manual: $(MAN)
unpack: $(UNPACKED)
resources: $(RESOURCES)
chars: $(CHARS)
status: $(STATUS)
ctan: $(CTAN_ZIP)
tds: $(TDS_ZIP)
world: all ctan

$(GLYPHS): /dev/null
	$(DO_GLYPHS)

$(CHARS): /dev/null
	$(DO_CHARS)

$(STATUS): /dev/null
	$(DO_STATUS)

$(GRAPHED): $(DOT)
	$(DO_GRAPHVIZ)

$(COMPILED): $(DTX)
	$(DO_LATEX)

$(UNPACKED): $(DTX)
	$(DO_TEX)

$(MAN): $(MANSOURCE)
	$(DO_DOCUTILS)

$(CTAN_ZIP): $(SOURCE) $(COMPILED) $(TDS_ZIP)
	@echo "Making $@ for CTAN upload."
	@$(RM) -- $@
	@zip -9 $@ $^ >/dev/null

define run-install
@mkdir -p $(SCRIPTDIR) && cp $(SCRIPTSTATUS) $(SCRIPTDIR)
@mkdir -p $(RUNDIR) && cp $(RUNSTATUS) $(RUNDIR)
@mkdir -p $(DOCDIR) && cp $(DOCSTATUS) $(DOCDIR)
@mkdir -p $(SRCDIR) && cp $(SRCSTATUS) $(SRCDIR)
@mkdir -p $(MANDIR) && cp $(MANSTATUS) $(MANDIR)
endef

$(TDS_ZIP): TEXMFROOT=./tmp-texmf
$(TDS_ZIP): $(ALL_STATUS)
	@echo "Making TDS-ready archive $@."
	@$(RM) -- $@
	$(run-install)
	@cd $(TEXMFROOT) && zip -9 ../$@ -r . >/dev/null
	@$(RM) -r -- $(TEXMFROOT)

.PHONY: install manifest clean mrproper

install: $(ALL_STATUS)
	@echo "Installing in '$(TEXMFROOT)'."
	$(run-install)

check: $(RUNSTATUS) $(TESTSTATUS_TL)
	@rm -rf var
	@for f in $(TESTSTATUS_TL); do \
	    echo "check: luatex $$f"; \
	    luatex --interaction=batchmode $$f \
	    > /dev/null || exit $$?; \
	    done

check-all: $(TESTSTATUS_SYS) check
	@cd $(TESTDIR); for f in $(TESTSTATUS_SYS); do \
	    echo "check: luatex $$f"; \
	    $(TESTENV) luatex --interaction=batchmode ../$$f \
	    > /dev/null || exit $$?; \
	    done

manifest: 
	@echo "Source files:"
	@for f in $(SOURCE); do echo $$f; done
	@echo ""
	@echo "Derived files:"
	@for f in $(GENERATED); do echo $$f; done

clean: 
	@$(RM) -- *.log *.aux *.toc *.idx *.ind *.ilg *.out $(TESTDIR)/*.log

mrproper: clean
	@$(RM) -- $(GENERATED) $(ZIPS) $(GLYPHSOURCE) $(TESTDIR)/*.pdf

=== debian/changelog ===
texlive-base (2013.20130722-1) unstable; urgency=low

  * new upstream checkout
  * conflict with texlive common so that it gets removed (Closes: #710789)
  * add Polish debconf translation, thanks to Michał Kułach
    (Closes: #711235)
  * update tlmgr (and with new upstream also TLUtils.pm) to support
    map files in user mode

 -- Norbert Preining <preining@debian.org>  Mon, 22 Jul 2013 17:35:16 +0900

texlive-base (2013.20130530-1) unstable; urgency=low

  * new upstream checkout, corresponding to TL2013 DVD release
  * adjust tl-paper to always read the (known good) system provided
    paper config files, or the ones provided by the sysadmin, instead
    of the generated one in TEXMFSYSVAR while setting paper sizes
    (Closes: #709986)

 -- Norbert Preining <preining@debian.org>  Thu, 30 May 2013 11:45:33 +0900

texlive-base (2013.20130523-1) unstable; urgency=low

  * new upstream checkout
  * turn user mode permanently on in tlmgr, and make tlmgr actually work

 -- Norbert Preining <preining@debian.org>  Thu, 23 May 2013 12:56:48 +0900

texlive-base (2013.20130520-2) unstable; urgency=low

  * fix wrong definition of TEXMFLOCAL

 -- Norbert Preining <preining@debian.org>  Mon, 20 May 2013 16:38:21 +0900

texlive-base (2013.20130520-1) unstable; urgency=low

  * new upstream checkout

 -- Norbert Preining <preining@debian.org>  Mon, 20 May 2013 13:11:20 +0900

texlive-base (2012.20130315-1) experimental; urgency=low

  * new upstream checkout
  * fix typo in license to make lintian license check happy (Closes: #698666)
  * unfuzzify patches

 -- Norbert Preining <preining@debian.org>  Sat, 16 Mar 2013 11:53:07 +0900

texlive-base (2012.20130111-1) experimental; urgency=low

  * new upstream checkout
  * replace/breaks with older context versions shipping texmfcnf.lua
    (Closes: #696169)

 -- Norbert Preining <preining@debian.org>  Fri, 11 Jan 2013 08:25:20 +0900

texlive-base (2012.20121205-1) experimental; urgency=low

  * new upstream checkout
  * rework doc file handling, doc files are now placed in their
    proper place in the TDS hierarchy

 -- Norbert Preining <preining@debian.org>  Thu, 06 Dec 2012 01:14:11 +0900

texlive-base (2012.20121125-1) experimental; urgency=low

  * new upstream checkout
  * incorporate many patches from texlive-bin for scripts that have been
    formerly in texlive-bin (foremost fmtutil!)

 -- Norbert Preining <preining@debian.org>  Sun, 25 Nov 2012 12:07:15 +0900

texlive-base (2012.20121123-1) experimental; urgency=low

  * new upstream checkout
  * new translation for Japanese (Closes: #683127, #690697)
  * provide symbolic links for some fonts (.pfb/.afm) files
    (Closes: #689837, #546251)

 -- Norbert Preining <preining@debian.org>  Fri, 23 Nov 2012 12:34:53 +0900

=== debian/control ===
Source: texlive-base
Section: tex
Priority: optional
Maintainer: Debian TeX Maintainers <debian-tex-maint@lists.debian.org>
Uploaders: Norbert Preining <preining@debian.org>, Frank Küster <frank@debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: sharutils, tex-common (>= 3), eperl, findutils (>=4.2.0)
Standards-Version: 3.9.3
Homepage: http://www.tug.org/texlive/

Package: texlive-base
Architecture: all
Depends: xdg-utils, tex-common (>= 4.03), ucf, libpaper-utils, ${misc:Depends}, texlive-binaries (>= 2013.20130512), luatex (>= 0.70.1)
Conflicts: ptex-bin (<< 2013.20130512), texlive-metapost-doc (<< 2013.20130512), texlive-fonts-recommended-doc (<< 2013.20130512), texlive-font-utils (<< 2013.20130512), texlive-latex-base (<< 2013.20130512), texlive-publishers (<< 2013.20130512), texlive-lang-danish, texlive-formats-extra (<< 2013.20130512), texlive-lang-all (<< 2013.20130512), texlive-fonts-recommended (<< 2013.20130512), texlive-common, texlive-science (<< 2013.20130512), texlive-lang-czechslovak (<< 2013.20130512), texlive-lang-cjk (<< 2013.20130512), texlive-full (<< 2013.20130512), texlive-pictures (<< 2013.20130512), texlive-base (<< 2013.20130512), texlive-metapost (<< 2013.20130512), texlive-latex-recommended-doc (<< 2013.20130512), texlive-lang-greek (<< 2013.20130512), texlive-generic-extra (<< 2013.20130512), texlive-lang-european (<< 2013.20130512), texlive (<< 2013.20130512), texlive-lang-mongolian, texlive-lang-italian (<< 2013.20130512), texlive-lang-swedish, texlive-lang-english (<< 2013.20130512), texlive-latex3 (<< 2013.20130512), pdfjam (<< 2013.20130512), texlive-lang-hebrew, texlive-humanities (<< 2013.20130512), texlive-binaries (<< 2013.20130512), texlive-lang-vietnamese, texlive-lang-croatian, texlive-music (<< 2013.20130512), texlive-lang-portuguese (<< 2013.20130512), texlive-lang-polish (<< 2013.20130512), texlive-lang-indic (<< 2013.20130512), texlive-luatex (<< 2013.20130512), thailatex (<< 2013.20130512), texlive-lang-norwegian, texlive-lang-arabic (<< 2013.20130512), texlive-omega (<< 2013.20130512), texlive-lang-lithuanian, texlive-pictures-doc (<< 2013.20130512), texlive-extra-utils (<< 2013.20130512), texlive-latex-extra-doc (<< 2013.20130512), texlive-lang-african (<< 2013.20130512), texlive-xetex (<< 2013.20130512), texlive-science-doc (<< 2013.20130512), texlive-fonts-extra-doc (<< 2013.20130512), texlive-bibtex-extra (<< 2013.20130512), texlive-doc-base, texlive-lang-armenian, texlive-lang-finnish, texlive-latex-extra (<< 2013.20130512), texlive-lang-tibetan, texlive-fonts-extra (<< 2013.20130512), texlive-games (<< 2013.20130512), texlive-lang-other (<< 2013.20130512), texlive-latex-base-doc (<< 2013.20130512), texlive-pstricks-doc (<< 2013.20130512), texlive-lang-cyrillic (<< 2013.20130512), texlive-lang-spanish (<< 2013.20130512), texlive-lang-latvian, texlive-lang-french (<< 2013.20130512), texlive-latex-recommended (<< 2013.20130512), texlive-plain-extra (<< 2013.20130512), texlive-humanities-doc (<< 2013.20130512), texpower (<< 2013.20130512), texlive-math-extra (<< 2013.20130512), texlive-pstricks (<< 2013.20130512), texlive-lang-dutch, texlive-lang-german (<< 2013.20130512), texlive-generic-recommended (<< 2013.20130512), texlive-publishers-doc (<< 2013.20130512), texlive-lang-hungarian, texlive-lang-latin
Recommends: lmodern (>= 0.93.3)
Provides: dvipdfmx
Suggests: ghostscript, perl-tk, gv | postscript-viewer, xpdf-reader | pdf-viewer
Replaces: texlive-doc-en, texlive-common (<< 2013), context (<< 2012.05.30.20121209), texlive-binaries (<< 2013), texlive-doc-base
Breaks: context (<< 2012.05.30.20121209)
Description: TeX Live: Essential programs and files
 These files are regarded as basic for any TeX system, covering plain TeX
   macros, Computer Modern fonts, and configuration for common drivers; no
   LaTeX.
 .
 This package includes the following CTAN packages:
  texlive.infra -- basic TeX Live infrastructure
  amsfonts -- TeX fonts from the American Mathematical Society.
  bibtex -- Process bibliographies for LaTeX, etc.
  cm -- Computer Modern fonts.
  dvipdfmx -- An extended version of dvipdfm.
  dvipdfmx-def -- Configuration file for dvipdfmx graphics.
  dvips -- A DVI to PostScript driver.
  enctex -- A TeX extension that translates input on its way into TeX.
  etex -- An extended version of TeX, from the NTS project.
  etex-pkg -- E-TeX support package.
  glyphlist --
  gsftopk -- Convert "ghostscript fonts" to PK files.
  hyph-utf8 -- Hyphenation patterns expressed in UTF-8.
  hyphen-base --
  ifluatex -- Provides the \ifluatex switch.
  ifxetex -- Am I running under XeTeX?
  kpathsea -- Path searching library for TeX-related files.
  lua-alt-getopt -- Process application arguments the same way as
   getopt_long.
  luatex -- The LuaTeX engine.
  makeindex -- Process index output to produce typesettable code.
  metafont -- A system for specifying fonts.
  mflogo -- LaTeX support for MetaFont logo fonts.
  mfware -- Supporting tools for use with Metafont.
  misc --
  pdftex -- A TeX extension for direct creation of PDF.
  plain --
  tetex -- scripts and files originally written for or included in teTeX
  tex -- A sophisticated typesetting engine.
  texconfig --
  texlive-common -- TeX Live documentation (common elements)
  texlive-docindex -- top-level TeX Live doc.html, etc.
  texlive-en -- TeX Live manual (English)
  xdvi -- A DVI previewer for the X Window System.
  texdoc -- Documentation access for TeX distributions.

Package: texlive-generic-recommended
Architecture: all
Depends: texlive-base (>= 2013.20130512), ${misc:Depends}, texlive-base (>= 2013.20130512)
Description: TeX Live: Generic recommended packages
 Recommended packages that work with multiple formats.
 .
 This package includes the following CTAN packages:
  epsf -- Simple macros for EPS inclusion.
  fontname -- Scheme for naming fonts in TeX.
  genmisc --
  kastrup --
  multido -- A loop facility for Generic TeX.
  path -- Typeset paths, making them breakable.
  tex-ps -- TeX to PostScript generic macros and add-ons.
  ulem -- Package for underlining.

Package: texlive-latex-base
Architecture: all
Depends: texlive-base (>= 2013.20130512), ${misc:Depends}, texlive-base (>= 2013.20130512), texlive-binaries (>= 2013.20130512)
Recommends: texlive-latex-base-doc
Description: TeX Live: LaTeX fundamental packages
 These packages are mandated by the core LaTeX team, or at least very
   strongly recommended.
 .
 This package includes the following CTAN packages:
  ae -- Virtual fonts for T1 encoded CMR-fonts.
  amscls -- AMS document classes for LaTeX.
  amsmath -- AMS mathematical facilities for LaTeX.
  babel -- Multilingual support for Plain TeX or LaTeX.
  babel-english --
  babelbib -- Multilingual bibliographies.
  carlisle -- David Carlisle's small packages.
  colortbl -- Add colour to LaTeX tables.
  fancyhdr -- Extensive control of page headers and footers in LaTeX2e.
  fix2col -- Fix miscellaneous two column mode features.
  geometry -- Flexible and complete interface to document dimensions.
  graphics -- Standard LaTeX graphics.
  hyperref -- Extensive support for hypertext in LaTeX.
  latex -- A TeX macro package that defines LaTeX.
  latex-bin -- LaTeX executables and man pages.
  latex-fonts -- A collection of fonts used in LaTeX distributions.
  latexconfig --
  ltxmisc -- Miscellaneous LaTeX packages, etc.
  mfnfss -- Packages to typeset oldgerman and pandora fonts in LaTeX.
  mptopdf -- mpost to PDF, native MetaPost graphics inclusion
  natbib -- Flexible bibliography support.
  oberdiek -- A bundle of packages submitted by Heiko Oberdiek.
  pdftex-def -- Colour and Graphics support for PDFTeX.
  pslatex -- Use PostScript fonts by default.
  psnfss -- Font support for common PostScript fonts.
  pspicture -- PostScript picture support.
  tools -- The LaTeX standard tools bundle.

Package: texlive-latex-recommended
Architecture: all
Depends: texlive-base (>= 2013.20130512), ${misc:Depends}, texlive-latex-base (>= 2013.20130512), texlive-binaries (>= 2013.20130512)
Recommends: latex-xcolor (>= 2.09), texlive-latex-recommended-doc, prosper (>= 1.00.4+cvs.2006.10.22), latex-beamer (>= 3.06.dfsg.1-0.1)
Provides: texlive-latex3
Description: TeX Live: LaTeX recommended packages
 A collection of recommended add-on packages for LaTeX which have widespread
   use.
 .
 This package includes the following CTAN packages:
  anysize -- A simple package to set up document margins.
  booktabs -- Publication quality tables in LaTeX
  caption -- Customising captions in floating environments.
  cite -- Improved citation handling in LaTeX.
  cmap -- Make PDF files searchable and copyable.
  crop -- Support for cropmarks.
  ctable -- Flexible typesetting of table and figure floats using key/value
   directives.
  ec -- Computer modern fonts in T1 and TS1 encodings.
  eso-pic -- Add picture commands (or backgrounds) to every page.
  euler -- Use AMS Euler fonts for math.
  extsizes -- Extend the standard classes' size options.
  fancybox -- Variants of \fbox and other games with boxes.
  fancyref -- A LaTeX package for fancy cross-referencing.
  fancyvrb -- Sophisticated verbatim text.
  float -- Improved interface for floating objects.
  fontspec -- Advanced font selection in XeLaTeX and LuaLaTeX.
  fp -- Fixed point arithmetic.
  index -- Extended index for LaTeX including multiple indexes.
  jknapltx -- Miscellaneous packages by Joerg Knappen.
  koma-script -- A bundle of versatile classes and packages
  l3kernel -- LaTeX3 programming conventions.
  l3packages -- High-level LaTeX3 concepts.
  l3experimental -- Experimental LaTeX3 concepts.
  listings -- Typeset source code listings using LaTeX.
  mdwtools -- Miscellaneous tools by Mark Wooding.
  memoir -- Typeset fiction, non-fiction and mathematical books.
  metalogo -- Extended TeX logo macros.
  mh -- The MH bundle
  microtype -- Subliminal refinements towards typographical perfection.
  ms -- Various LaTeX packages by Martin Schroder.
  ntgclass -- "European" versions of standard classes.
  parskip -- Layout with zero \parindent, non-zero \parskip.
  pdfpages -- Include PDF documents in LaTeX.
  powerdot -- A presentation class.
  psfrag -- Replace strings in encapsulated PostScript figures.
  rcs -- Use RCS (revision control system) tags in LaTeX documents.
  rotating -- Rotation tools, including rotated full-page floats.
  sansmath -- Maths in a sans font.
  section -- Modifying section commands in LaTeX.
  seminar -- Make overhead slides.
  sepnum -- Print numbers in a "friendly" format.
  setspace -- Set space between lines.
  subfig -- Figures broken into subfigures
  textcase -- Case conversion ignoring mathematics, etc.
  thumbpdf -- Thumbnails for pdfTeX and dvips/ps2pdf.
  typehtml -- Typeset HTML directly from LaTeX.
  underscore -- Control the behaviour of "_" in text.
  url -- Verbatim with URL-sensitive line breaks.
  xkeyval -- Extension of the keyval package.

Package: texlive-fonts-recommended
Section: fonts
Architecture: all
Depends: texlive-base (>= 2013.20130512), ${misc:Depends}, texlive-base (>= 2013.20130512), ttf-marvosym
Recommends: tipa (>= 2:1.2-2.1), tex-gyre, texlive-fonts-recommended-doc
Description: TeX Live: Recommended fonts
 Recommended fonts, including the base 35 PostScript fonts, Latin Modern, TeX
   Gyre, and T1 and other encoding support for Computer Modern, in outline
   form.
 .
 This package includes the following CTAN packages:
  avantgar -- URW "Base 35" font pack for LaTeX.
  bookman -- URW "Base 35" font pack for LaTeX.
  charter -- Charter fonts.
  cmextra --
  courier -- URW "Base 35" font pack for LaTeX.
  euro -- Provide Euro values for national currency amounts.
  euro-ce -- Euro and CE sign font.
  eurosym -- MetaFont and macros for Euro sign.
  fpl -- SC and OsF fonts for URW Palladio L
  helvetic -- URW "Base 35" font pack for LaTeX.
  lm-math -- OpenType maths fonts for Latin Modern.

=== debian/rules ===
#!/usr/bin/make -f
# 
# debian/rules file for texlive-base

PACKAGES=texlive-base texlive-generic-recommended texlive-latex-base texlive-latex-recommended texlive-fonts-recommended texlive-pictures texlive-luatex texlive-metapost texlive-omega texlive-xetex texlive-fonts-recommended-doc texlive-latex-base-doc texlive-latex-recommended-doc texlive-metapost-doc texlive-pictures-doc
METAPACKAGES=texlive texlive-full

SHELL=/bin/bash

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	touch build-stamp

clean: 
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  rm -f debian/$$i.{README.Debian,links,links.generated} ; \
	  rm -f debian/$$i.{postinst,postrm,preinst,prerm} ; \
	  rm -f debian/$$i.{maps,hyphens,formats,info,manpages} ; \
	  rm -f debian/$$i.{lintian-overrides} ; \
	done
	rm -f debian/texlive-base.cnf
	# texlive contains some .orig files we need to keep otherwise
	# the copy will fail due to the files occurring in the tlpdb
	dh_clean -X.orig -X.bak
	rm -f configure-stamp
	rm -f build-stamp
	rm -f install-stamp

install: install-stamp

install-stamp: build-stamp
	# make sure we have texmf-dist/web2c otherwise the media detection
	# might break (like in texlive-lang)
	mkdir -p texmf-dist/web2c
	perl debian/tpm2deb-bin.pl --nosource $(PACKAGES) $(METAPACKAGES)
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  bash debian/generate-license-file $$i ; \
	  if [ -r debian/$$i.links.dist ] ; then cat debian/$$i.links.dist >> debian/$$i.links ; fi ; \
	done
	mkdir -p debian/texlive-base/etc/texmf/texdoctk
	mv debian/texlive-base/usr/share/texlive/texmf-dist/texdoctk/texdocrc.defaults \
	  debian/texlive-base/etc/texmf/texdoctk
	rmdir --ignore-fail-on-non-empty debian/texlive-base/usr/share/texlive/texmf-dist/texdoctk
	# link pfb/afm files (type1 fonts) into /usr/share/fonts
	for i in $(PACKAGES) $(METAPACKAGES) ; do \
	  bash debian/create-font-links $$i >> debian/$$i.links ; \
	done
	touch install-stamp

binary-arch:

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_install
	dh_installdirs
	dh_installmenu
	dh_lintian
	dh_bugfiles -A
	dh_installdocs -A debian/README.source debian/README.Debian
	dh_installdocs -p texlive-base README readme-txt.dir readme-html.dir debian/CHANGES.packaging
	# nasty trick
	# mptopdf needs a dump, but is a link to a script
	# we have to trick dh_installtex to accept it
	mv debian/texlive-latex-base/usr/bin/mptopdf	\
		debian/texlive-latex-base/usr/bin/mptopdf.bck
	ln -s pdftex debian/texlive-latex-base/usr/bin/mptopdf
	dh_installtex -Ntexlive-base -A --priority=10	\
		$(patsubst %,-N%,$(METAPACKAGES))	\
		--flavor=lsr:full,tree:texlive
	# nasty trick undoing
	rm debian/texlive-latex-base/usr/bin/mptopdf
	mv debian/texlive-latex-base/usr/bin/mptopdf.bck	\
		debian/texlive-latex-base/usr/bin/mptopdf
	# end of nasty trick
	dh_installtex -ptexlive-base --priority=10	\
		--flavor=format:build_all,lsr:full,tree:texlive
	# /usr/bin/mf has been created by dh_installtex as symlink to 
	# mf-nowin, but is also shipped by texlive-binaries, remove it.
	rm debian/texlive-base/usr/bin/mf
	# furthermore we want to have etex and pdfetex as links in 
	# texlive-binaries and not in texlive-base, remove them here
	# and add them via dh_link in texlive-binaries
	# this is just out of history, would be nicer to have changed
	rm debian/texlive-base/usr/bin/etex 
	rm debian/texlive-base/usr/bin/pdfetex
	# for the libpaper hook, install templates and
	# translations. No need to modify postrm. I hope it accepts
	# the missing config script
	dh_installdebconf -n
	cp debian/texlive-base.libpaper debian/texlive-base/etc/libpaper.d/texlive-base
	chmod a+x debian/texlive-base/etc/libpaper.d/texlive-base
	dh_installchangelogs
	dh_installman
	bash debian/fix-manpages.sh
	# info pages
	bash debian/convert-info-files-to-unix.sh
	dh_installinfo
	# remove info files that are present in texlive-binaries
	# has to be done after the dh_installinfo call
	rm debian/texlive-base/usr/share/info/dvips.info*
	rm debian/texlive-base/usr/share/info/web2c.info*
	rm debian/texlive-base/usr/share/info/kpathsea.info*
	rmdir --ignore-fail-on-non-empty debian/texlive-base/usr/share/info
	dh_installmime
	dh_lintian
	dh_link
	dh_compress -X.pdf
	dh_fixperms
	# remove .bat files, nobody needs them
	find debian/texlive-*/usr/share/texlive/texmf-dist/ -name \*.bat -a -type f -exec rm '{}' \;
	# remove x bit from files in the doc hierarchy
	find debian/texlive-*/usr/share/doc/texlive-doc -type f -exec chmod a-x '{}' \;
	# we also have to fix the permissions of the link targets from /usr/bin
	bash debian/fix-bin-symlink-targets-permissions.sh
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb -- -Zxz

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install

# eof
